// ROK to LWO converter
// 96-8-6 
// 96-11-2 0.04
//
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <mbstring.h>

typedef unsigned long DWORD;

struct ROKPOINT {
	int num;
	short group;
	short show;
	//int dummy;
	int dim;
	double x,y,z;
};

struct ROKLINE {
	int p1, p2;
	short group;
	short show;
	int num_face;
	int * faces;

	void add_face( int a_face ) {
		faces = (int *)realloc(faces, ++num_face * sizeof(int));
		faces[num_face - 1] = a_face;
	}
};
class ROKCLUSTER {
public:
	int num_face;
	struct ROKFACE ** faces;
	ROKCLUSTER() : num_face(0), faces(0) {}
	void add_face( ROKFACE * face ) {
		faces = (ROKFACE **)realloc( faces, ++num_face * sizeof (ROKFACE *) );
		faces[num_face - 1] = face;
	}
};

struct ROKFACE {
	int num_line;
	int color;
	int no;
	ROKLINE **lines;

	ROKCLUSTER * cluster;
};

struct ROKPAL {
	int lred, lgreen, lblue;
	int dred, dgreen, dblue;
};

int num_points;
ROKPOINT * points;
int num_lines;
ROKLINE * lines;
int num_faces;
ROKFACE * faces;
int numpal;
ROKPAL * palette;
int numcluster;
ROKCLUSTER ** cluster;
 
char *fgets2( char *string, int n, FILE *stream ) {
	int c;
	int len;
	if ( feof(stream) )
		return NULL;
	for ( len = 0 ; len < n - 1 ; ++len ) {
		c = fgetc(stream);
		if ( c < 0 ) break;
		if ( c == '\r' || c == '\n' ) {
			int c2 = fgetc(stream);
			if ( c2 == c || (c2 != '\r' && c2 != '\n') ) {
				ungetc(c2, stream);
			}
			//string[len++] = '\n';
			break;
		}
		string[len] = (char)c;
	}
	string[len] = '\0';
	return string;
}

void trace_faces( ROKFACE * f, ROKCLUSTER * c ) {
	if ( !f->cluster ) {
		f->cluster = c;
		c->add_face( f );
		int i, j;
		for ( i = 0 ; i < f->num_line ; ++i ) {
			ROKLINE* lin = f->lines[i];
			for ( j = 0 ; j < lin->num_face ; ++j ) {
				trace_faces( &faces[lin->faces[j]], c );
			}
		}
	}
}

int read_rok( FILE * fp ) {
	char buf[6];
	int result = 0;
	int i;
	fread( buf, 5, 1, fp );
	if ( buf[0] == 0 ) {
		fseek( fp, 128 - 5, SEEK_CUR );
		fread( buf, 5, 1, fp );
	}
	if ( memcmp( buf, "ROKU4", 5 ) != 0 ) {
		result = -1;
		goto quit;
	}
	char linebuf[80];
	fgets2(linebuf, sizeof linebuf, fp ); // ROKU4̒̉ŝĂ

	// wb_
	while ( !feof(fp) ) {
		fgets2(linebuf, sizeof linebuf, fp );
		if ( strcmp( linebuf, "POINT" ) == 0 ) {
			break;
		}
	}
	// _
	points = 0;
	num_points = 0;
	while ( !feof(fp) ) {
		fgets2(linebuf, sizeof linebuf, fp );
		if ( strcmp( linebuf, "LINE0" ) == 0 ) {
			break;
		}
		points = (ROKPOINT *)realloc(points, ++num_points * sizeof *points);
		ROKPOINT& mypoint = points[num_points - 1];
		mypoint.num = atoi( linebuf );

		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.group = (short)atoi( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.show = (short)atoi( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.dim = atoi( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.x = atof( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.y = atof( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		mypoint.z = atof( linebuf );
	}

	// Ő
	num_lines = 0;
	lines = 0;
	while ( !feof(fp) ) {
		fgets2(linebuf, sizeof linebuf, fp );
		if ( strcmp( linebuf, "FACE0" ) == 0 ) {
			break;
		}
		lines = (ROKLINE *)realloc(lines, ++num_lines * sizeof *lines);
		ROKLINE * myline = &lines[num_lines - 1];
		myline->p1 = atoi( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		myline->p2 = atoi( linebuf );

		fgets2(linebuf, sizeof linebuf, fp );
		myline->group = (short)atoi( linebuf );
		fgets2(linebuf, sizeof linebuf, fp );
		myline->show = (short)atoi( linebuf );

		// pĂʂ̃Xg
		myline->faces = 0;
		myline->num_face = 0;
	}
	// 
	num_faces = 0;
	faces = 0;
	while ( !feof(fp) ) {
		fgets2(linebuf, sizeof linebuf, fp );
		if ( strcmp( linebuf, "END00" ) == 0 ) {
			break;
		}
		++num_faces;
		faces = (ROKFACE *)realloc(faces, num_faces * sizeof *faces);
		ROKFACE * myface = &faces[num_faces - 1];
		int nl = myface->num_line = atoi( linebuf );
		myface->lines = (ROKLINE **)malloc(nl * sizeof *myface->lines );
		fgets2(linebuf, sizeof linebuf, fp );
		myface->color = atoi( linebuf );

		fgets2(linebuf, sizeof linebuf, fp );
		myface->no = atoi( linebuf );

		// NX^ԍ
		myface->cluster = 0;

		// ̗ŐXg /
		for ( i = 0 ; i < nl ; ++i ) {
			fgets2(linebuf, sizeof linebuf, fp );
			int linenum = atoi(linebuf) - 1;
			ROKLINE * lin = &lines[linenum];
			myface->lines[i] = lin;

			// ŐɂAgĂʂ̃Xgi[ /
			lin->add_face( num_faces - 1 );
		}
	}
	numpal = 0;
	palette = 0;

	// 
	while ( !feof(fp) ) {
		fgets2(linebuf, sizeof linebuf, fp );
		if ( strcmp( linebuf, "PALC0" ) == 0 ) {
			// pbg
			fgets2(linebuf, sizeof linebuf, fp );
			numpal = atoi( linebuf );
			palette = (ROKPAL *)malloc( numpal * sizeof *palette );

			fgets2(linebuf, sizeof linebuf, fp );
			int i;
			for ( i = 0 ; i < numpal ; ++i ) {
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].lred = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].lgreen = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].lblue = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].dred = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].dgreen = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp );
				palette[i].dblue = atoi(linebuf);
				fgets2(linebuf, sizeof linebuf, fp ); // dummy
			}
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDP0" ) == 0 ) {
					break;
				}
			}
		} else if ( strcmp( linebuf, "BAKC0" ) == 0 ) {
			// wiF
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDB0" ) == 0 ) {
					break;
				}
			}
		} else if ( strcmp( linebuf, "LIT00" ) == 0 ) {
			// 
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDL0" ) == 0 ) {
					break;
				}
			}
		} else if ( strcmp( linebuf, "VIEW0" ) == 0 ) {
			// \
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDV0" ) == 0 ) {
					break;
				}
			}
		} else if ( strcmp( linebuf, "LINE2" ) == 0 ) {
			// ̃vpeB
#if 1
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDL2" ) == 0 ) {
					break;
				}
				int linenum = atoi(linebuf) - 1;
				ROKLINE * lin = &lines[linenum];
				fgets2(linebuf, sizeof linebuf, fp ); // ̎ ()
				fgets2(linebuf, sizeof linebuf, fp ); // ̐F 
				int color = atoi( linebuf );
				fgets2(linebuf, sizeof linebuf, fp ); // ̑()
				int use_line = 1;
#if 1
				use_line = !(lin->show);
#else
				int i;
				for ( i = 0 ; i < lin->num_face ; ++i ) {
					if ( faces[lin->faces[i]].num_line == 1 ) {
						break;
					}
					if ( faces[lin->faces[i]].num_line > 1 ) {
						use_line = 0;
						break;
					}
				}
#endif
				if ( use_line ) {
					++num_faces;
					faces = (ROKFACE *)realloc(faces, num_faces * sizeof *faces);
					ROKFACE * myface = &faces[num_faces - 1];
					myface->num_line = 1;
					myface->lines = (ROKLINE **)malloc(sizeof *myface->lines);
					myface->color = color;

					myface->no = 0; // ??

					// NX^ԍ
					myface->cluster = 0;

					// ̗ŐXg /
					myface->lines[0] = lin;

					// ŐɂAgĂʂ̃Xgi[ /
					lin->add_face( num_faces - 1 );
				}
			}
#else
			while ( !feof(fp) ) {
				fgets2(linebuf, sizeof linebuf, fp );
				if ( strcmp( linebuf, "ENDL2" ) == 0 ) {
					break;
				}
			}
#endif
		}
	}

	// אڂĂʂ̃Xg
	numcluster = 0;
	cluster = 0;
	for ( i = 0; i < num_faces ; ++i ) {
		if ( !faces[i].cluster ) {
			cluster = (ROKCLUSTER **)realloc(cluster, ++numcluster * sizeof (ROKCLUSTER *) );
			cluster[numcluster - 1] = new ROKCLUSTER();
			trace_faces( &faces[i], cluster[numcluster - 1] );
		}
	}

	return 0;

quit:
	return -1;
}

class Chunk {
	int size;
	char * buf;
	Chunk * parent;
	FILE * fp;
public:
	Chunk(): size(0), buf(0), fp(0), parent(0) {}
	int open( const char * cname, FILE * ifp ) {
		fp = ifp;
		parent = 0;
		size = 0;
		buf = 0;
		return fwrite( cname, 4, 1, fp );
	}
	int open( const char * cname, Chunk& iparent ) {
		fp = 0;
		parent = &iparent;
		size = 0;
		buf = 0;
		return parent->write( cname, 4 );
	}
	int close() {
		if ( size ) {
			if ( fp ) {
				putc( (char)(size >> (8*3)), fp);
				putc( (char)(size >> (8*2)), fp);
				putc( (char)(size >> (8*1)), fp);
				putc( (char)(size >> (8*0)), fp);
				fwrite( buf, size, 1, fp );
			} else {
				DWORD dw = size;
				parent->dword(&dw);
				parent->write(buf, size);
			}
			free(buf);
			buf = 0;
			size = 0;
			fp = 0;
			parent = 0;
		}
		return 0;
	}
	int write( const char * data, int len ) {
		int newsize = size + len;
		buf = (char *)realloc(buf, newsize);
		memcpy( buf + size, data, len);
		size = newsize;
		return 0;
	}

	int puts( const char * str ) {
		int len = strlen(str) + 1;
		int newsize = size + ((len + 1) & ~1);
		buf = (char *)realloc(buf, newsize);
		memcpy( buf + size, str, len);
		if ( len & 1 )
			buf[size+len] = 0;
		size = newsize;
		return 0;
	}
	int dword( DWORD * val ) {
		char nval[4];
		nval[0] = (char)(*val >> 8*3);
		nval[1] = (char)(*val >> 8*2);
		nval[2] = (char)(*val >> 8);
		nval[3] = (char)(*val >> 0);
		return write( nval, 4 );
	}
	int shortint( short val ) {
		char nval[2];
		nval[0] = (char)(val >> 8);
		nval[1] = (char)(val >> 0);
		return write( nval, 2 );
	}
};

int write_rok_to_lwo( FILE * fp ) {
	int i;
	Chunk cont;
	Chunk chunk;
	cont.open( "FORM",fp );
	cont.write( "LWOB", 4 );

	char name[16];
	int use_surfs[16];
	int trans_surfs[16];
	memset( use_surfs, 0, sizeof use_surfs );
	for ( i = 0 ; i < num_faces ; ++i ) {
		use_surfs[faces[i].color] = 1;
	}
	int n = 0;
	for ( i = 0 ; i < 16 ; ++i ) {
		if ( use_surfs[i] ) {
			trans_surfs[i] = ++n;
		}
	}

	chunk.open( "SRFS", cont );
	for ( i = 0 ; i < numpal ; ++i ) {
		if ( use_surfs[i] ) {
			sprintf( name, "ROK%d", i );
			chunk.puts( name );
		}
	}
	chunk.close();

	chunk.open( "PNTS", cont );
	for ( i = 0 ; i < num_points ; ++i ) {
		union f_dw {
			float f;
			DWORD dw;
		} w;
		w.f = (float)(points[i].x *  8.); chunk.dword( &w.dw );
		w.f = (float)(points[i].y * -8.); chunk.dword( &w.dw );
		w.f = (float)(points[i].z *  8.); chunk.dword( &w.dw );
	}
	chunk.close();

	chunk.open( "POLS", cont );
	for ( i = 0 ; i < num_faces ; ++i ) {
		if ( faces[i].num_line == 1 ) {
			chunk.shortint( (short)2 );
			chunk.shortint( (short)(faces[i].lines[0]->p1 - 1) );
			chunk.shortint( (short)(faces[i].lines[0]->p2 - 1) );
		} else {
			chunk.shortint( (short)faces[i].num_line );
			int p1 = 0;
			int p1_p1 = 1;
			int n;
			for ( n = 0 ; n < faces[i].num_line ; ++n ) {
				int k;
				int p, rp;
				if ( p1_p1 ) {
					p = faces[i].lines[p1]->p1 - 1;
					rp = faces[i].lines[p1]->p2;
				} else {
					p = faces[i].lines[p1]->p2 - 1;
					rp = faces[i].lines[p1]->p1;
				}

				chunk.shortint( (short)(p) );
				for ( k = 0 ; k < faces[i].num_line ; ++k ) {
					if ( k != p1 ) {
						if ( rp == faces[i].lines[k]->p1 ) {
							p1_p1 = 1;
							break;
						}
						if ( rp == faces[i].lines[k]->p2 ) {
							p1_p1 = 0;
							break;
						}
					}
				}
				p1 = k;
			}
		}
		chunk.shortint( (short)trans_surfs[faces[i].color] );
	}
	chunk.close();

	//chunk.open( "CRVS", cont );
	//chunk.close();

	for ( i = 0 ; i < numpal ; ++i ) {
		if ( use_surfs[i] ) {
			chunk.open( "SURF", cont );
			sprintf( name, "ROK%d", i );
			chunk.puts(name);
			chunk.write( "COLR", 4 );
			chunk.shortint( 4 );
			char four[4];
			int lInten = palette[i].lgreen * 4 + palette[i].lred * 2 + palette[i].lblue;
			int dInten = palette[i].dgreen * 4 + palette[i].dred * 2 + palette[i].dblue;
			four[0] = (char)((palette[i].lred   + palette[i].dred) / 2);
			four[1] = (char)((palette[i].lgreen + palette[i].dgreen) / 2);
			four[2] = (char)((palette[i].lblue  + palette[i].dblue) / 2);
			four[3] = 0;
			chunk.write( four, 4 );

			chunk.write( "FLAG", 4 );
			chunk.shortint( 2 );
			chunk.shortint( 0x104 /* 0x100 /* double sided */ );

			chunk.write( "SMAN", 4 );
			union f_dw {
				float f;
				DWORD dw;
			} w;
			chunk.shortint(4);
			w.f = (float)(44.5 * 3.141592653589 / 180.); chunk.dword( &w.dw );

			chunk.write( "DIFF", 4 );
			chunk.shortint( 2 );
			chunk.shortint( 0x100 );

			chunk.write( "TRAN", 4 );
			chunk.shortint( 2 );
			chunk.shortint( 0 );

			chunk.write( "SPEC", 4 );
			chunk.shortint( 2 );
			if ( lInten > dInten ) {
				int whiteInten = 255 * 4 + 255 * 2 + 255;
				int cInten = (lInten + dInten) / 2;
				int percent = (lInten - cInten) * 256 / (whiteInten - cInten) / 4;
				chunk.shortint( (short)percent );
			} else {
				chunk.shortint( 0 );
			}

			chunk.write( "GLOS", 4 );
			chunk.shortint( 2 );
			chunk.shortint( 0 );

			chunk.close();
		}
	}

	cont.close();

	return 0;
}

const char * find_basename( const char * filename ) {
	const unsigned char * rp = (const unsigned char *)filename;
	const unsigned char * basename = rp;
	while ( *rp ) {
		unsigned char c = *rp;
		rp = _mbsinc(rp);
		if ( c == ':' || c == '/' || c == '\\' ) {
			basename = rp;
		}
	}
	return (const char *)basename;
}

void replace_ext( char * filename, const char * new_ext ) {
	unsigned char * rp = (unsigned char *)filename;
	unsigned char * dotp = 0;
	while ( *rp ) {
		char c = *rp;
		if ( c == ':' || c == '/' || c == '\\' ) {
			dotp = 0;
		} else if ( c == '.' ) {
			dotp = rp;
		}
		rp = _mbsinc(rp);
	}
	if ( dotp == 0 )
		dotp = rp;
	strcpy( (char *)dotp, new_ext );
}

int rok_to_lwo( const char * filename ) {
	int result = 0;
	FILE * fp;
	fp = fopen(filename, "rb");
	if ( !fp ) {
		printf( "could not open: %s\n", filename );
		return -1;
	}
	int a = read_rok(fp);
	fclose(fp);
	if ( a >= 0 ) {
		char lwoname[1024];
		strcpy( lwoname, find_basename(filename) );
		replace_ext( lwoname, ".LWO" );
		fp = fopen( lwoname, "wb" );
		if ( !fp ) {
			printf( "could not create: %s\n", lwoname );
			return -1;
		}
		a = write_rok_to_lwo(fp);
		fclose( fp );
		if ( a < 0 ) {
			result = -1;
			unlink( lwoname );
		}
	}
	return result;
}



int main(int argc, char *argv[]) {
	if ( argc != 2 ) {
		printf( "ROK to LWO converter 0.04  by A.Koiuka\n"
				"usage: rok2lwo <.rok file>\n" );
		return EXIT_FAILURE;
	}
	int a = rok_to_lwo(argv[1]);
	if ( a < 0 ) {
		printf( "error occured.\n" );
		return EXIT_FAILURE;
	}
	return EXIT_SUCCESS;
}